<template>
    <div class="context">
        <div class="panel">
            <h5>操作日志</h5>
            <div class="panel-body">
                <div class="panel_control">
                    <el-row :gutter="20">
                        <el-col :span="5">
                            <el-date-picker
                                    v-model="panel.timeScope"
                                    type="daterange"
                                    range-separator="至"
                                    start-placeholder="开始日期"
                                    end-placeholder="结束日期">
                            </el-date-picker>
                        </el-col>
                        <el-col :span="4">
                            <em>操作者:</em>
                            <el-select v-model="panel.userId">
                                <el-option
                                        v-for="item in panel.options"
                                        :key="item.value"
                                        :label="item.label"
                                        :value="item.value">
                                </el-option>
                            </el-select>
                        </el-col>
                        <el-col :span="4">
                            <em>手机号:</em>
                            <el-input v-model="panel.phone" placeholder="请输入手机号"></el-input>
                        </el-col>
                        <el-col :span="4">
                            <el-button size="" type="primary" @click="query" plain>查询</el-button>
                        </el-col>
                    </el-row>
                </div>
            </div>
        </div>
        <div class="table">
            <el-table
                    :data="tableData"
                    border
                    is-horizontal-resize
                    :default-sort="{prop: 'date', order: 'descending'}"
                    element-loading-background="rgba(0, 0, 0, 0.8)"
                    class=""
                    @selection-change="handleSelectionChange"

            >
                <el-table-column
                        type="index"
                        label="序号"
                        width="50">
                </el-table-column>
                <el-table-column
                        prop="CreatedAt"
                        label="日期"
                        :formatter="filterFmtDate"
                        sortable
                >
                </el-table-column>
                <el-table-column
                        prop="OptName"
                        label="操作者"
                        sortable
                >
                </el-table-column>
                <el-table-column
                        prop="OptPhone"
                        label="手机号"
                >
                </el-table-column>
                <el-table-column
                        prop="Parameter"
                        label="执行语句"
                        sortable
                >
                    <template slot-scope="scope">
                        <el-popover
                                placement="top"
                                title="具体语句"
                                width="200"
                                trigger="hover"
                                :content="scope.row.Parameter">
                            <span slot="reference"
                                  v-if="scope.row.Parameter.length > 20">{{scope.row.Parameter.substr(0,20)}} ....</span>
                        </el-popover>
                        <span v-if="scope.row.Parameter.length <= 20">{{scope.row.Parameter}}</span>
                    </template>
                </el-table-column>
                <el-table-column
                        prop="OptInfo"
                        label="操作信息"
                        sortable
                >
                </el-table-column>
                <el-table-column
                        prop="Result"
                        label="操作结果"
                        sortable
                >
                </el-table-column>
            </el-table>
            <br>
            <el-pagination
                    background
                    :total="pageination.total"
                    :page-size="pageination.pageItem"
                    @current-change="pageChange"
            ></el-pagination>
        </div>

        <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="360px">
            <div>
                <el-form ref="form" :model="form" label-width="80px">
                    <el-form-item label="手机号">
                        <el-input v-model="form.userCode"></el-input>
                    </el-form-item>
                    <el-form-item label="姓名">
                        <el-input v-model="form.name"></el-input>
                    </el-form-item>
                    <el-form-item label="所属门店">
                        <el-select v-model="form.shopId" placeholder="请选择所属门店">
                            <el-option
                                    v-for="item in shops"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value"
                            ></el-option>
                        </el-select>
                    </el-form-item>
                </el-form>
            </div>
            <div class="dialogFooter">
                <el-button type="primary" size="small" @click="confirmAdmin">确定</el-button>
                <el-button @click="dialogVisible = false" size="small">取消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
    import Global from '../Global.js'
    import {
        OptLogListQuery,
        testTable,
        testSelect, ShopManagerListQuery
    } from "../api/getApiRes";

    let qs = require('qs');
    export default {
        data() {
            return {
                dialogVisible: false,
                dialogTitle: '新增管理员',
                times: globalBt2(7),
                // panel 配置项目
                panel: {
                    userCode: '',
                    tel: '',
                    userId: '',
                    shopList: 0,
                    options: [],
                    draw: 1,
                    start: 0,
                    recordsTotal: 0,
                    tableData: [],
                    allTableData: [],
                    limit: '10',
                    multipleSort: false,
                    loading: false,
                    fileList: [],
                    multipleSelection: [],
                    detectedmac: '',
                    time1: globalBt(),
                    timeScope: globalBt2(30),
                },
                multipleSelection: [],
                pageination: {
                    pageItem: 100,
                    pageoptions: pageOptions(),
                    total: 100,
                    pageIndex: 1,
                },
                form: {
                    name: '',
                    userCode: '',
                    shopId: '',
                },
                shops: [],
                tableData: []
            }
        },
        mounted() {
            this.panelSelect();
            this.getTableQuery();
        },
        methods: {
            // 新增 确认提交
            confirmAdmin() {
                let that = this;
                // checkNum
                if (!that.form.userCode) {
                    this.$message.error('错了哦，手机号不能为空');
                    return false
                }
                if (!globalCheckPhone(that.form.userCode)) {
                    this.$message.error('错了哦，手机号格式不正确');
                    return false
                }
                if (!that.form.name) {
                    this.$message.error('错了哦，姓名不能为空');
                    return false
                }
                if (that.form.name.length > 8) {
                    this.$message.error('错了哦，姓名字数超过8个字');
                    return false
                }
                let param = {
                    token: localStorage.token,
                    userCode: that.form.userCode,
                    name: that.form.name,
                    shopid: that.form.shopid,
                };
                let postdata = qs.stringify(param);
                testSelect(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        // 关闭弹窗
                        that.dialogVisible = false;
                        // 重载列表
                        that.getTableQuery();
                        that.$message({
                            showClose: true,
                            message: '管理员添加成功！',
                            type: 'success'
                        });
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            // 加载选项
            panelSelect() {
                let that = this;
                let param = {
                    token: localStorage.token,
                    start: 1,
                    tableMax: 999,
                };
                let postdata = qs.stringify(param);
                ShopManagerListQuery(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        that.panel.options = this.turnResToOptionByUsers(json.Rs);
                        that.panel.options.unshift({value: '', label: "全部"});
                        console.log( that.panel.options);
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            turnResToOptionByUsers(data) {
                if (!data) return false
                let ids = data.map(item => {
                    return {
                        label: item.Name + ' ' + item.Phone,
                        key: parseInt(item.Id),
                        value: parseInt(item.Id),
                    }
                })
                return ids
            },
            // 删除
            delList() {
                let that = this;
                // checkNum
                if (!this.multipleSelection.length) {
                    that.$message({
                        showClose: true,
                        message: '错了哦，需要先选中至少一条记录',
                        type: 'error'
                    });
                    return false
                }
                if (this.multipleSelection.length != 1) {
                    that.$message({
                        showClose: true,
                        message: '错了哦，只能选中一条记录',
                        type: 'error'
                    });
                    return false
                }
                let detectorid = that.multipleSelection[0].Id;

                let param = {
                    token: localStorage.token,
                    detectorid: detectorid,
                    status: 9,//0禁用1启用9删除
                };
                let postdata = qs.stringify(param);

                this.$confirm('此操作将永久删除该管理员, 是否继续?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {
                    testSelect(postdata).then(res => {
                        let json = res;
                        if (json.Code == 0) {
                            that.$message({
                                showClose: true,
                                message: '选中的管理员已删除！',
                                type: 'success'
                            });
                            // 重载列表
                            that.getTableQuery();
                        } else {
                            that.$message.error(json.Memo);
                        }
                    });
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '已取消删除'
                    });
                });
            },
            clearForm() {
                // clear
                this.form.name = '';
                this.form.userCode = '';
                this.form.shopId = '';
            },
            // 新增管理员
            addAdmin() {
                this.clearForm();
                this.dialogVisible = true
                this.dialogTitle = '新增管理员'
            },
            // 编辑管理员
            editList(row) {
                this.clearForm();
                this.form.name = row.name;
                this.form.userCode = row.userCode;
                this.form.shopId = row.Id;
                this.dialogVisible = true
                this.dialogTitle = '编辑管理员'
            },
            handleSelectionChange(val) {
                this.multipleSelection = val;
            },
            // 查询按钮
            query() {
                this.getTableQuery();
                this.$message.success('查询完毕');
            },
            // 页面数据查询
            getTableQuery() {
                console.log( this.panel.userId);
                let that = this;
                // this.getGetChildRegionSelect(0, 1);
                that.loading = true;
                // 查询检测设备。上级区域id，区域id必传。regionid传0，查询supregionid对应所有子区域的检测设备。 如果supregionid，regionid都传0，默认查询企业ID下所有检测设备
                let param = {
                    token: localStorage.token,
                    name: this.panel.name,
                    phone: this.panel.phone,
                    userId: this.panel.userId,
                    bt: nonTfmtDate(that.panel.timeScope[0], 10),
                    et: nonTfmtDate(that.panel.timeScope[1], 10),
                    start: 1,//
                    tableMax: 9999,//
                };
                let postdata = qs.stringify(param);
                OptLogListQuery(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        that.loading = false;
                        if (json.Rs) {
                            that.allTableData = json.Rs;
                            that.recordsTotal = json.Rs.length;
                        } else {
                            that.allTableData = [];
                            that.recordsTotal = 0;
                        }
                        // 设置分页数据
                        that.setPaginations();
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            // 设置分页数据
            setPaginations() {
                // 分页属性
                let that = this;
                that.pageination.total = that.recordsTotal;
                // 默认分页
                that.tableData = that.allTableData.filter((item, index) => {
                    return index < that.pageination.pageItem;
                });
            },
            // 每页显示数量
            handleSizeChange() {
                let that = this;
                that.tableData = that.allTableData.filter((item, index) => {
                    return index < that.pageination.pageItem;
                });
                that.draw = that.pageination.pageItem;
                that.getTableQuery();
            },
            // 翻页
            pageChange(pageIndex) {
                let that = this;
                // 获取当前页
                let index = that.pageination.pageItem * (pageIndex - 1);
                // 数据总数
                let nums = that.pageination.pageItem * pageIndex;
                // 容器
                let tables = [];
                for (var i = index; i < nums; i++) {
                    if (that.allTableData[i]) {
                        tables.push(that.allTableData[i])
                    }
                    this.tableData = tables;
                }
                that.start = index * that.draw;
                that.getTableQuery();
            },
            // 自动排序
            sortChange(params) {
                console.log(params)
            },
            // 过滤时间
            filterFmtDate(value, row, column) {
                let that = this;
                return nonTfmtDate(column, 11);
            },
        },
    }
</script>

<style scoped>
    @import "../assets/css/panel.css";

    .context {   height: 770px;
         overflow-y: scroll;

        display: block;
        margin: 0 auto;
        background-color: #fff !important;
        padding: 30px;
        padding-bottom: 60px;
    }

    .panel-body {
        padding: 20px;
        background: #F0F2F5;
    }

    .change {
        width: 100%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        padding-top: 10px;
        padding-bottom: 10px;
    }

    .change button {
        float: left;
    }

    .change button.pull-right {
        float: right;
    }

    .dialogTitle {
        width: 100%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        color: #000000;
        font-size: 18px;
        text-align: center;
    }

    .dialogTitle em {
        float: none;
        font-style: normal;
        color: #3799FF;
        margin: 0;
    }

    /deep/ .el-transfer-panel__item .el-checkbox__input {
        left: 40px;
    }

    .dialogFooter {
        width: 90%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        margin-top: 10px;
    }

    .dialogFooter button {
        float: right;
        margin-left: 10px;
    }

    /deep/ .el-date-editor .el-range__icon {
        line-height: 22px;
    }

    .panel /deep/ .el-date-editor .el-range-separator {
        line-height: 22px;
    }
</style>
